Package: csodata
Type: Package
Title: Download Data from the CSO 'PxStat' API
Version: 1.2.2
Date: 2021-12-10
Authors@R: c(
    person("Eoin", "Horgan", email = "eoin.horgan@cso.ie", role = "aut", comment = c(ORCID = "0000-0002-3446-6154")),
	person("Conor", "Crowley", email = "conor.crowley@cso.ie", role = c("aut", "cre")),
	person("Vytas", "Vaiciulis", email = "Vytas.Vaiciulis@cso.ie", role = c("aut")),
    person("Mervyn", "O'Luing", email = "mervyn.oluing@cso.ie", role = "aut"))
Maintainer: Conor Crowley <conor.crowley@cso.ie>
Description: Imports 'PxStat' data in JSON-stat format and (optionally) reshapes it into wide
	format. The Central Statistics Office (CSO) is the national statistical institute of Ireland
	and 'PxStat' is the CSOs online database of Official Statistics. This database contains current
	and historical data series compiled from CSO statistical releases and is accessed at
	<http://data.cso.ie>.
	The CSO 'PxStat' Application Programming Interface (API), which is accessed in this package, provides
	access to 'PxStat' data in JSON-stat format at <http://data.cso.ie>.
	This dissemination tool allows developers machine to machine access to CSO 'PxStat' data.
Imports: dplyr, httr, jsonlite, reshape2, rjstat, R.cache, sf,
        lubridate
License: GPL-3
Encoding: UTF-8
RoxygenNote: 7.1.1
Suggests: knitr, rmarkdown, tmap, viridisLite
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2021-12-10 14:06:24 UTC; crowleyco
Author: Eoin Horgan [aut] (<https://orcid.org/0000-0002-3446-6154>),
  Conor Crowley [aut, cre],
  Vytas Vaiciulis [aut],
  Mervyn O'Luing [aut]
Repository: CRAN
Date/Publication: 2021-12-10 15:00:05 UTC

# CSO Ireland Data
==============================

Easily download data from the CSO PxStat API as Pandas datasets.

Uses [requests-cache](https://github.com/requests-cache/requests-cache) for super fast access to cached requests and easy persistence with multiple storage backends.

## Installation
To install, just use pip:
```bash
pip install cso-ireland-data
```

## Usage
### Getting started
First, set up a `CSODataSession`. 

* By default, this is really simple.

    ```python
    from cso_data import CSODataSession
    cso = CSODataSession()
    ```

* If you want to add caching, no problem! All the functionality of [the `requests-cache` package](https://github.com/requests-cache/requests-cache) is available through `cached_session_params`.
    ```python
    from datetime import timedelta
    from cso_data import CSODataSession

    cso = CSODataSession(
        cached_session_params={
            "use_cache_dir": True,  # Save files in the default user cache dir
            "cache_control": True,  # Use Cache-Control response headers for expiration, if available
            "expire_after": timedelta(days=1),  # Otherwise expire responses after one day
        }
    )
    ```
* Stuck behind a corporate firewall that causes SSL certificate issues? Also no problem! All the functionality of [the `requests` `get()` method](https://requests.readthedocs.io/en/latest/user/quickstart/) is available through `request_params`.

    ```python
    from cso_data import CSODataSession

    # Tell requests.get() it's ok not to verify SSL certificates when getting data.
    # !!! Only do this if you're absolutely sure it's what you need !!!
    cso = CSODataSession(request_params={"verify": False})
    ```
### Getting the data catalogue
To get a catalogue (Table of Contents) of all the datasets that are available through the API, use `get_toc()`.

NB Requests for the ToC sometimes time out on the CSO API. IF this happens, try again!


```python
cso.get_toc()
```

| table_id   | table_name                                           | last_updated              | copyright                          | exceptional   | frequency   |   earliest |   latest | variables                                                          |
|:-----------|:-----------------------------------------------------|:--------------------------|:-----------------------------------|:--------------|:------------|-----------:|---------:|:-------------------------------------------------------------------|
| A0101      | 1996 Population and Percentage Change  1991 and 1996 | 2020-05-01 11:00:00+00:00 | Central Statistics Office, Ireland | False         | CensusYear  |       1996 |     1996 | ['Province County or City']                                        |
| A0102      | Population at Each Census Since 1841                 | 2020-05-01 11:00:00+00:00 | Central Statistics Office, Ireland | False         | CensusYear  |       1841 |     1996 | ['Province or County', 'Sex']                                      |
| A0103      | Population                                           | 2020-05-01 11:00:00+00:00 | Central Statistics Office, Ireland | False         | CensusYear  |       1996 |     1996 | ['Province County or City', 'Sex', 'Aggregate Town or Rural Area'] |
| A0104      | Population                                           | 2020-06-03 11:00:00+00:00 | Central Statistics Office, Ireland | False         | CensusYear  |       1996 |     1996 | ['Sex', 'Regional Authority']                                      |
| A0105      | 1996 Population and Percentage Change 1996 and 2002  | 2021-07-19 11:00:00+00:00 | Central Statistics Office, Ireland | False         | CensusYear  |       1996 |     1996 | ['Towns by Electoral Division']                                    |

### Getting a table using its ID code
To get the whole contents of a particular table hosted on the Statbank API, use `get_table()`.

You just need to know the ID code of the table, which you can look up using `get_toc()`.
```python
wpm29 = cso.get_table("WPM29")
wpm29.head()
```

|                           |   Wholesale Price Index (Excl VAT) for Energy Products |
|:--------------------------|-------------------------------------------------------:|
| ('Autodiesel', '2015M01') |                                                   96.7 |
| ('Autodiesel', '2015M02') |                                                  102   |
| ('Autodiesel', '2015M03') |                                                  103   |
| ('Autodiesel', '2015M04') |                                                  102.9 |
| ('Autodiesel', '2015M05') |                                                  104.6 |

### Getting some common tables quickly
The `CSODataSession` class includes some useful methods to get data from commonly accessed tables quickly. 

#### Monthly Consumer Price Index (CPI)
By default, the `cpi()` method returns a single column corresponding to the 'All items' headline CPI in the source table. 

Also by default, this index is re-normalized to the most recent month - you can toggle this by setting `normalize_to_most_recent` to `False`.

```python
simple_cpi = cso.monthly_cpi()
simple_cpi.tail()
```

| Month               |   All items |
|:--------------------|------------:|
| 2022-04-01 00:00:00 |      0.9725 |
| 2022-05-01 00:00:00 |      0.981  |
| 2022-06-01 00:00:00 |      0.9937 |
| 2022-07-01 00:00:00 |      0.9986 |
| 2022-08-01 00:00:00 |      1      |

It's also possible to pass a list of commodity groups:

```python
commmodity_group_cpi = cso.monthly_cpi(
    commodity_groups=[
        "All items",
        "Alcoholic beverages and tobacco",
        "Health",
        "Recreation and culture",
    ]
)
commodity_group_cpi.tail()
```

| Month               |   All items |   Alcoholic beverages and tobacco |   Health |   Recreation and culture |
|:--------------------|------------:|----------------------------------:|---------:|-------------------------:|
| 2022-04-01 00:00:00 |      0.9725 |                            0.9738 |   0.9828 |                   0.9945 |
| 2022-05-01 00:00:00 |      0.981  |                            0.9937 |   0.9851 |                   0.9954 |
| 2022-06-01 00:00:00 |      0.9937 |                            0.9958 |   0.9874 |                   0.9973 |
| 2022-07-01 00:00:00 |      0.9986 |                            0.9969 |   0.9874 |                   0.9991 |
| 2022-08-01 00:00:00 |      1      |                            1      |   1      |                   1      |1      |                   1      |

#### Live Register
Use the `live_register()` method to get Live Register numbers (optionally broken down by Age Group and Sex) by month. This is a long data series, starting in April 1967 and still continuing every month, so it may be convenient to specify a `start` and/or `end` date for the data returned.

The Live Register data series is based on a monthly point-in-time count of people who have active Jobseeker claims with the Department of Social Protection (DSP), and these counts are extracted from DSP's administrative computer systems on a particular day every month. 

Because of this, `live_register()` returns three possibly useful dates for each month:
1. 'Month' is the index of the data frame. It's just the last day of each calendar month.
2. 'reference_date' is the date of the point-in-time count of people with active Jobseeker claims. It's the last Friday of each month before May 2015, and the last Thursday of the month from then on.
3. 'extract_date' is the date on which the source administrative data was actually extracted - it's always the Sunday after the reporting_date.
   
```python
live_register = cso.live_register(start=datetime(2010, 1, 1))

```

|     | Month               | Age Group   | Sex        |   Persons on the Live Register |   Persons on the Live Register (Seasonally Adjusted) | reference_date      | extract_date        |
|----:|:--------------------|:------------|:-----------|-------------------------------:|-----------------------------------------------------:|:--------------------|:--------------------|
| 516 | 2010-04-30 00:00:00 | All ages    | Both sexes |                         432657 |                                               440800 | 2010-04-30 00:00:00 | 2010-05-02 00:00:00 |
| 517 | 2010-08-31 00:00:00 | All ages    | Both sexes |                         466923 |                                               444000 | 2010-08-27 00:00:00 | 2010-08-29 00:00:00 |
| 518 | 2010-12-31 00:00:00 | All ages    | Both sexes |                         437079 |                                               446000 | 2010-12-31 00:00:00 | 2011-01-02 00:00:00 |
| 519 | 2010-02-28 00:00:00 | All ages    | Both sexes |                         436956 |                                               439000 | 2010-02-26 00:00:00 | 2010-02-28 00:00:00 |
| 520 | 2010-01-31 00:00:00 | All ages    | Both sexes |                         436936 |                                               439400 | 2010-01-29 00:00:00 | 2010-01-31 00:00:00 |
#### Life Tables
The `life_table()` method by default returns a complete life table for the most recent source data vintage.

```python
life_table = cso.life_table()
life_table.head()
```

|               |     Ix |   dx |       px |       qx |    Lx |          Tx |   e0x |
|:--------------|-------:|-----:|---------:|---------:|------:|------------:|------:|
| ('Female', 0) | 100000 |  304 | 0.99696  | 0.00304  | 99848 | 8.34235e+06 | 83.42 |
| ('Female', 1) |  99696 |   22 | 0.999784 | 0.000216 | 99685 | 8.2425e+06  | 82.68 |
| ('Female', 2) |  99674 |    7 | 0.999933 | 6.7e-05  | 99671 | 8.14281e+06 | 81.69 |
| ('Female', 3) |  99668 |    5 | 0.999948 | 5.2e-05  | 99665 | 8.04314e+06 | 80.7  |
| ('Female', 4) |  99663 |    6 | 0.999936 | 6.4e-05  | 99659 | 7.94348e+06 | 79.7  |

#' Return geographic data as a sf data frame
#'
#' Retrieves an ESRI shapefile of vector data for Ireland from the cso website
#' \href{https://www.cso.ie/en/census/census2011boundaryfiles/}{cso.ie} and
#' returns it as an sf data frame. The data is returned as a zip file, which is
#' downloaded to and unzipped in a temporary directory.
#'
#' The map data is from the 2011 census, and is 20m generalised, which offers a
#' good balance of fidelity and low file size. More datasets, as well as
#' 50m generalised, 100m generalised and ungeneralised versions of the map
#' files can also be found on the OSi (Ordnance Survey Ireland) website at
#' \url{https://data-osi.opendata.arcgis.com/search?tags=boundaries}.
#'
#' The NUTS2 and NUTS3 map files are the updated versions for 2016, including
#' three NUTS2 regions and the movement of Louth and South Tipperary into new
#' NUTS3 regions. These files are downloaded directly from the OSi website, as
#' they are not available on the CSO website, and do not contain the population
#' and housing data contained in the map files from the CSO website.
#'
#' @param map_data string. Indicates which shapefile to download. Options are:
#' \itemize{
#'   \item "Provinces" OR "p",
#'   \item "NUTS2",
#'   \item "NUTS3",
#'   \item "NUTS2_2011",
#'   \item "NUTS3_2011",
#'   \item "Administrative Counties" OR "admin_counties" OR "ac",
#'   \item "Electoral Divisions" OR "elec_div" OR "ed",
#'   \item "Small Areas" OR "sa" and
#'   \item "Gaeltacht" OR "g".
#' }
#' Until v0.1.5 "NUTS2" and "NUTS3" gave access to the 2011 dataset.
#' @param cache logical. Indicates whether to cache the result using R.cache.
#' TRUE by default.
#' @param flush_cache logical. If TRUE (default) the cache will be checked for old, unused
#' files. Any files which have not been accessed in the last month will be deleted
#' @return data frame of the requested CSO table.
#' @export
#' @examples
#' \dontrun{
#' shp <- cso_get_geo("NUTS2")
#' }

cso_get_geo <- function(map_data, cache = TRUE, flush_cache = TRUE) {
  dl_path <- "https://census.cso.ie/censusasp/saps/boundaries/"
  # Set shapefile name ------------------
  fname <- dplyr::case_when(
    map_data == "Provinces" || map_data == "p" ~
      "Census2011_Province_generalised20m",
    map_data == "NUTS2" ~ "NUTS2_Boundaries_Generalised_20m__OSi_National_Statistical_Boundaries__2015",
    map_data == "NUTS3" ~ "NUTS3_Boundaries_Generalised_20m__OSi_National_Statistical_Boundaries__2015",
    map_data == "NUTS2_2011" ~ "Census2011_NUTS2_generalised20m",
    map_data == "NUTS3_2011" ~ "Census2011_NUTS3_generalised20m",
    map_data == "Administrative Counties" ||
      map_data == "admin_counties" || map_data == "ac" ~
      "Census2011_Admin_Counties_generalised20m",
    map_data == "Electoral Divisions" ||
      map_data == "elec_div" || map_data == "ed" ~
      "Census2011_Electoral_Divisions_generalised20m",
    map_data == "Small Areas" || map_data == "sa" ~
      "Census2011_Small_Areas_generalised20m",
    map_data == "Gaeltacht" || map_data == "g" ~
      "Census2011_Gaeltacht",
    TRUE ~ NA_character_
  )
  
  # Need to separate error check. Including it in case_when causes error ---
  if (is.na(fname)) {
    stop("Not one of the available map files.")
  }
  
  if (map_data == "NUTS2") {
    url <- "https://opendata.arcgis.com/datasets/62e0cf326bab442897944e4dc4999c16_2.zip"
  } else if (map_data == "NUTS3") {
    url <- "https://opendata.arcgis.com/datasets/1a5d91a11ad9454d865ad426bbf5bc37_2.zip"
  } else {
    url <- paste0(dl_path, fname, ".zip")
  }
  
  # Retreive cached data ----------------
  if (cache) {
    data <- R.cache::loadCache(list(fname), dirs = "csodata/geodata")
    if (!is.null(data)) {
      message("Loaded cached data\n")
      return(data)
    }
  }
  
  #Empty out the cache of unused files if a new file is being downloaded
  if(flush_cache){
    file.remove(
      rownames(
        fileSnapshot(paste0(R.cache::getCacheRootPath(),"/csodata"), full.names = T, recursive = T)$info[!lubridate::`%within%`(
          fileSnapshot(paste0(R.cache::getCacheRootPath(),"/csodata"), full.names = T, recursive = T)$info[,"mtime"],
          lubridate::interval(start = Sys.Date()- lubridate::days(2) , end = Sys.Date() + lubridate::days(1))) , ]
      )
    )
  }
  
  # No caching, or cache empty ----------
  tmpdir <- tempdir()
  filepath <- paste0(tmpdir, "/", fname, ".zip")
  
  # Error Messaging --------
  error_message =  paste0("Failed retrieving map data. Please check internet",
                          " connection and that cso.ie and opendata.arcgis.com are online")
  if (httr::http_error(url)) {
    print(paste0("Error: ", error_message))
    return(NULL)
  } else {
    utils::download.file(url, filepath)
  }
  
  utils::unzip(filepath, exdir = tmpdir)
  if (map_data == "NUTS2") {
    shape_file <- paste0(tmpdir, "/", "c2f2dbb3-289e-45cc-ae79-791cbc9339632020330-1-1uh3380.g89t.shp")
  } else if ( map_data == "NUTS3"){
    shape_file <- paste0(tmpdir, "/", "527c3332-32cc-44cd-baa3-267a0e917b5a2020328-1-1cpklcw.flb0h.shp")
  } else{
    shape_file <- paste0(tmpdir, "/", fname, ".shp")
  }
  
  shp <- sf::st_read(shape_file, stringsAsFactors = F)
  
  
  if (map_data == "NUTS2" | map_data == "NUTS3") {
    # Transform OSi maps to use Irish grid projection, like CSO maps
    ire_proj = "+proj=tmerc +lat_0=53.5 +lon_0=-8 +k=1.000035 +x_0=200000 +y_0=250000 +datum=ire65 +units=m +no_defs"
    shp <- sf::st_transform(shp, ire_proj)
  }
  
  if (cache) {
    R.cache::saveCache(shp, key = list(fname), dirs = "csodata/geodata")
  }
  return(shp)
}


#' Returns a data frame with the metadata of a vector shapefile
#'
#' Takes the output from \code{\link{cso_get_geo}} or otherwise and returns
#' information about it in a data frame.
#'
#' @param shp sf data.frame. Geographic data stored as an sf object.
#' @return list with eight elements:
#' \itemize{
#'   \item The coordinate reference system, itself a list with two elements,
#'   the EPSG code (if any, NA value if none), and the proj4string
#'   \item The number of polygons in the data
#'   \item If all the polygons are simple (not self-intersecting)
#'   \item If any polygons are empty
#'   \item If all of the polygons are valid
#'   \item The average area of the polygons, including units
#' }
#' @export
#' @examples
#' \dontrun{
#' shp_meta <- cso_get_geo_meta(shp)
#' }
cso_get_geo_meta <- function(shp) {
  crs <- sf::st_crs(shp)
  poly <- length(sf::st_dimension(shp))

  simp <- all(sf::st_is_simple(shp))
  empt <- any(sf::st_is_empty(shp))
  valid <- all(sf::st_is_valid(shp))
  avg_area <- mean(sf::st_area(shp))

  list(
    coordinate_reference_system = crs, polygons = poly, all_simple = simp,
    any_empty = empt, all_valid = valid, average_area = avg_area
  )
}


#' Prints metadata from an ESRI shapefile to console
#'
#' Takes the output from \code{\link{cso_get_geo}} or otherwise and prints
#' information about it to the console as formatted text.
#'
#' @param shp sf data.frame. Geographic data stored as an sf object.
#' @return Does not return any values, rather the function prints the shapefile metadata to console.
#' @export
#' @examples
#' \dontrun{
#' cso_disp_geo_meta(shp)
#' }
cso_disp_geo_meta <- function(shp) {
  contents <- setdiff(names(shp), "geometry")
  shp_meta <- cso_get_geo_meta(shp)
  #date_range <- range(as.POSIXlt(shp$CREATEDATE, format = "%d-%m-%Y", tz = "GMT"))

  message("*** GEOGRAPHIC METADATA ***")
  print(sf::st_crs(shp))
  message("\nPolygons = ", shp_meta$polygons, "\n")
  message("All polygons are simple? = ", shp_meta$all_simple, "\n")
  message("Any polygons is empty? = ", shp_meta$any_empty, "\n")
  message("All polygons are valid? = ", shp_meta$all_valid, "\n")
  #message("Creation date range = ", as.character(date_range[[1]]), "--", as.character(date_range[[2]]), "\n")
  message("Average polygon area = ")
  print(shp_meta$average_area)
  message("\n*** ADDITIONAL DATA INCLUDED ***")

  geoid <- c("NUTS1", "NUTS1NAME", "NUTS2", "NUTS2NAME", "NUTS3", "NUTS3NAME",
             "COUNTY", "COUNTYNAME", "GEOGID", "CSOED", "OSIED", "EDNAME",
             "GAELTACHT", "NAME", "PROVINCE", "PROVNAME", "SMALL_AREA")

  geoident <- contents[contents %in% geoid]

  message("\nGeographic identifiers:")
  print(geoident)

  pop <- contents[contents %in% c("MALE2011", "FEMALE2011", "TOTAL2011",
                                  "Male2011", "Female2011", "Total2011")]
  message("\nPopulation (Male, Female, Total):")
  print(pop)

  hs <- c("PPOCC2011", "UNOCC2011", "VACANT2011", "HS2011", "PCVAC20111",
          "PCVAC2011", "PPOcc2011", "Unocc2011", "Vacant2011", "PCVac2011")

  house <- contents[contents %in% hs]
  message("\nHousing figures:")
  print(house)

  area <- contents[contents %in% c("LAND_AREA", "TOTAL_AREA")]
  message("\nArea figures:")
  print(area)

  message("\nCreation/modification date:")
  print("CREATEDATE")

  other <- contents[!contents %in% c(geoident, pop, house, area, "CREATEDATE")]
  if (length(other) > 0) {
    message("Other data: \n")
    print(other)
  }
}

#' csodata: A package for downloading CSO data.
#'
#' The csodata package allows for easily downloading CSO (Central Statistics
#' Office, the National Statistics Institute of Ireland) PxStat data into R.
#'
#' A specific table can be downloaded using \code{\link{cso_get_data}},
#' while a list of all tables currently available and their titles can
#' be found using \code{\link{cso_get_toc}} and \code{\link{cso_search_toc}}
#' is used to search their descriptions.
#' Metadata for a specified table can be retrieved with
#' \code{\link{cso_get_meta}}, or printed on the console using
#' \code{\link{cso_disp_meta}}.
#'
#' \code{\link{cso_get_vars}}, \code{\link{cso_get_interval}}, and
#' \code{\link{cso_get_content}} all return a subset of the full metadata of
#' a table. \code{\link{cso_get_var_values}} returns all the variables in the
#' tables.
#'
#' These functions provide the option to cache the returned data using the
#' R.cache package. The cache can be deleted using
#' \code{\link{cso_clear_cache}}.
#'
#' ESRI shapefiles covering the country in varying degrees of granularity can
#' be downloaded from
#' \href{https://www.cso.ie/en/census/census2011boundaryfiles/}{cso.ie} and
#' imported as an sf data frame using the \code{\link{cso_get_geo}} function.
#' Metadata about the map data can be retrieved with
#' \code{\link{cso_get_geo_meta}}, and displayed on the console with
#' \code{\link{cso_disp_geo_meta}}.
#'
#' @docType package
#' @name csodata
NULL


#' Clear csodata cache
#'
#' Deletes all data cached by the csodata package. The cached data from the
#' csodata package is stored in a subdirectory of the default R.cache cache
#' at R.cache::getCachePath(). This function provides a quick way to delete
#' those files along with the directory to free up space.
#'
#'
#' @return Does not return a value, deletes the csodata cache.
#' @export
#' @examples
#' \dontrun{
#' cso_clear_cache()
#' }
cso_clear_cache <- function() {
  R.cache::clearCache(dirs = "csodata", recursive = TRUE, prompt = FALSE)
  unlink(paste0(R.cache::getCacheRootPath(),"/csodata"), recursive = TRUE, force = TRUE)
}

#' Returns a data frame with all valid CSO PxStat tables listed sequentially
#' by id number, e.g. A0101, A0102, A0103, etc.
#'
#' Checks the CSO PxStat API for a list of all the table codes (e.g. A0101,
#' A0102, A0103, etc.), which also includes date last modified and title for
#' each table, and returns this list as an R data frame.
#'
#' The data is pulled from the ReadCollection on the CSO API. See
#' \url{https://github.com/CSOIreland/PxStat/wiki/API-Cube-RESTful}
#' for more information on this.
#'
#' @param cache logical. If TRUE (default) the table of contents is cached
#' with the system date as a key.
#' @param suppress_messages logical. If FALSE (default) a message is printed
#' when loading a previously cached table of contents.
#' @param get_frequency logical. If TRUE the frequency of each 
#' table(yearly, monthly etc...) will be returned as an additional column in 
#' the table of contents
#' @param list_vars logical. If TRUE an additional column will be added
#' to the table of contents which lists each tables variables.
#' @param flush_cache logical. If TRUE (default) the cache will be checked for 
#' old, unused files. Any files which have not been accessed in the last month 
#' will be deleted
#' @return data frame of three character columns:
#' \itemize{
#'   \item id. Contains all of the table codes currently
#' available on the CSO API.
#'   \item LastModified. The date the table was last modified in POSIXct
#'   format.
#'   \item title. The title of the table.
#' }
#'
#' @export
#' @examples
#' \dontrun{
#' head(cso_get_toc())
#' }
  cso_get_toc <- function(cache = TRUE, suppress_messages = FALSE, get_frequency = FALSE, list_vars = FALSE, flush_cache = TRUE) {
    url <- paste0(
      
      "https://ws.cso.ie/public/api.restful/PxStat.Data.Cube_API.ReadCollection"
      
    )
    
    # cache
    if (cache) {
      data <- R.cache::loadCache(list("cso_toc", Sys.Date(),list_vars,get_frequency), dirs = "csodata")
      if (!is.null(data)) {
        if (!suppress_messages) {
          message("Loaded cached toc\n")
        }
        return(data)
      } }
    
    #Empty out the cache of unused files if a new file is being downloaded
    if(flush_cache){
      file.remove(
        rownames(
          fileSnapshot(paste0(R.cache::getCacheRootPath(),"/csodata"), full.names = T, recursive = T)$info[!lubridate::`%within%`(
            fileSnapshot(paste0(R.cache::getCacheRootPath(),"/csodata"), full.names = T, recursive = T)$info[,"mtime"],
            lubridate::interval(start = Sys.Date() - lubridate::days(2) , end = Sys.Date() + lubridate::days(1) )) , ]
        ) #lubridate::`%m+%`(Sys.Date(),months(-1)) 
      )
    }
    
    # Check for errors using trycatch since PxStat API does not support
    # html head requests.
    error_message =  paste0("Failed retrieving table of contents. Please ",
                            "check internet connection and that data.cso.ie is online")
    
    tbl <- tryCatch({
      data.frame(jsonlite::fromJSON(url))
      
    }, warning = function(w) {
      print(paste0("Warning: ", error_message))
      return(NULL)
    }, error = function(e) {
      print(paste0("Error: ", error_message))
      return(NULL)
    })
    
    if(is.null(tbl)){return(NULL)}
    
    tbl2 <- cbind(tbl[c("link.item.updated","link.item.label")],data.frame(tbl$link.item.extension$matrix))
    tbl3 <- dplyr::mutate_if(tbl2, is.factor, as.character)
    
    names(tbl3)[1] <- "LastModified"
    names(tbl3)[2] <- "title"
    names(tbl3)[3] <- "id"
    
    tbl3$LastModified <- as.POSIXct(tbl3$LastModified,
                                    format = "%M", tz = "GMT")
    
    if (get_frequency){
      tbl3 <- cbind(tbl3,
                    tbl$link.item.dimension$`TLIST(A1)`$label,
                    tbl$link.item.dimension$`TLIST(M1)`$label,
                    tbl$link.item.dimension$`TLIST(Q1)`$label,
                    tbl$link.item.dimension$`TLIST(W1)`$label,
                    tbl$link.item.dimension$`TLIST(H1)`$label,
                    tbl$link.item.dimension$`TLIST(D1)`$label
      )
      
      colnames(tbl3)[4:9] <- c("Tlist_A","Tlist_M","Tlist_Q","Tlist_H","Tlist_D","Tlist_W")
      
      #tbl3 <- data.frame(lapply(tbl3, as.character), stringsAsFactors=FALSE) # need make DF char for case_when function
      
      tbl3 <- dplyr::mutate(tbl3, ReleaseFrequency = dplyr::case_when(
        !is.na (Tlist_M) ~ Tlist_M,
        !is.na (Tlist_A) ~ Tlist_A,
        !is.na(Tlist_Q) ~ Tlist_Q,
        !is.na (Tlist_H) ~ Tlist_H,
        !is.na(Tlist_D) ~ Tlist_D,
        !is.na(Tlist_W) ~ Tlist_W,
        TRUE ~ NA_character_
      ))
      
      tbl3 <- tbl3[, c("LastModified","title","id","ReleaseFrequency")] # keep columns
    }
    
    if (list_vars){
      catlist <- lapply(tbl$link.item.id,setdiff, c("STATISTIC","TLIST(Q1)","TLIST(A1)","TLIST(M1)"))
      l2 <- c()
      for (i in 1:length(catlist)) {
        l <- c()
        for (j in 1:length(catlist[[i]])) {
          l <- append(l,tbl$link.item.dimension[catlist[[i]][j]][i,]$label)
        }
        l2[[i]] <- as.list(l)
      }
      tbl3$vars <- l2
    }
    
    
    
    if (cache){
      R.cache::saveCache(tbl3,
                         key = list("cso_toc", Sys.Date(), list_vars,get_frequency), dirs = "csodata"
      )
    }
    
    return(tbl3)
  }

#' Search list of all table descriptions for given string
#'
#' Searches the list of all table descriptions returned by cso_get_toc() for a
#' given substring.
#'
#' @param string string. The text to search for. Case insensitive.
#' @param toc data.frame. The table of contents as returned by cso_get_toc. If
#' not given, will be re-downloaded (or retrieved from cache) using
#' cso_get_toc().
#' @param flush_cache logical. If TRUE  the cache will be checked for old, unused
#' files. Any files wich have not been accessed in the last month will be deleted
#' strings.
#' @return data frame of three character columns, with layout identical to
#' that of cso_get_toc. A subset of the results of cso_get_toc, with only rows
#' where the description field contains the entered string.
#'
#' @export
#' @examples
#' \dontrun{
#' trv <- cso_search_toc("travel")
#' }
cso_search_toc <- function(string, toc = cso_get_toc(suppress_messages = TRUE, flush_cache = FALSE)) {
  # Error Checking ----------------------
  if (is.null(toc)) {
    return(NULL)
  }

  # Search string -----------------------
  pattern <- toupper(string)
  x <- toupper(toc$title)

  # Use grep to search ------------------
  toc[grep(pattern, x), ]
}

#' Return a CSO table as a data frame
#'
#' Returns a CSO table from the CSO PxStat Application Programming Interface
#' (API) as a data frame, with the option to give it in wide format (default)
#' very wide or long format.
#'
#' The data is pulled from the ResponseInstance service on the CSO API in
#' JSON-Stat fromat, using the GET method from the httr package.
#'
#' @param table_code string. If the table_code is a filename or a path to a
#' file, e.g. "QNQ22.json", it is imported from that file. Otherwise if it is
#' only a table code e.g. "QNQ22", the file is downloaded from data.cso and
#' checked to see if it is a valid table.
#' @param wide_format string, one of "wide", "very_wide" or "tall". If "wide"
#' (default) the table is returned in wide (human readable) format, with
#' statistic as a column (if it exists). If "very_wide" the table is returned
#' wide format and spreads the statistic column to rows. If "tall" the table is
#' returned in tall (statistic and value) format.
#' @param include_ids logical. The JSON-stat format stores variables as ids
#' i.e. IE11 and labels i.e. Border. While the label is generally preferred,
#' sometimes it is useful to have the ids to match on. If \code{include_ids}
#' is TRUE (default) then ids are retrieved and appended to the table to the
#' right of the original column with the name <columnName>.id.
#' @param id_list either NULL (default) or a character vector of columns that
#' should have ids appended if include_ids is TRUE.
#' if NULL then every column that is not included in the vector
#' \code{remove_id} will be used.
#' @param use_factors logical. If TRUE (default) factors will be used in
#' strings.
#' @param cache logical. if TRUE (default) csodata will cache the result using
#' R.cache. The raw data downloaded from the data.csi.ie is cached, which means
#' that calling \code{cso_get_data} with the same table_code but different
#' parameterswill result in cached data being used.
#' @param flush_cache logical. If TRUE (default) the cache will be checked for 
#' old, unused files. Any files which have not been accessed in the last month
#'  will be deleted
#' @return data frame of the requested CSO table.
#' @export
#' @examples
#' \dontrun{
#' tbl1 <- cso_get_data("QNQ22")
#' tbl2 <- cso_get_data("QLF07.json")
#' }
cso_get_data <- function(table_code, wide_format = "wide", include_ids = FALSE,
                         id_list = NULL, use_factors = TRUE, cache = TRUE, flush_cache = TRUE) {
  # Set path to or download data --------
  if (substr(
    table_code, nchar(table_code) - 4, nchar(table_code)
  ) == ".json") {
    if (file.exists(table_code)) {
      json_data <- table_code
    } else {
      stop("Not a valid path to a .json file")
    }
  } else {
    json_data <- cso_download_tbl(table_code, cache = cache, flush_cache = flush_cache)
    # Error Checking ----------------------
    if (is.null(json_data)) {
      return(NULL)
    }
  }
  
  # Load data ---------------------------
  data <- rjstat::fromJSONstat(json_data,
                               naming = "label", use_factors = use_factors
  )
  names(data) <- make.names(names(data), unique = TRUE)
  
  # Append ids as new column ------------
  if (include_ids) {
    data_id <- rjstat::fromJSONstat(json_data,
                                    naming = "id", use_factors = use_factors
    )
    names(data_id)[substr(names(data_id),0,1) == "C"] <-paste0(names(data)[substr(names(data_id),0,1) == "C"],".id")
    
    #Composing the list of id columns to be appended
    if (is.null(id_list)) {
      
      concat_id <- names(data_id)[grepl(".*id$",names(data_id))]
    } else if (all(id_list %in% names(data))){
      concat_id <- paste0(id_list,".id")
    } else {
      #There was an issue with the id_list
      stop("One or more columns supplied to id_list not found")
    }
    
    for (ID in concat_id) {
      id_list <- list(as.vector(as.matrix(data_id[ID])))
      names(id_list) <- ID
      data <- data.frame(append(data, id_list, after = match(substr(ID,0,nchar(ID)-3), names(data)) ),
                         stringsAsFactors = TRUE
      )
    }
  }
  
  # Pivot to wide table -----------------
  if (wide_format == "wide" || wide_format == "very_wide") {
    string <- names(data)
    remove <- c(
      "Year", "Quarter", "Month", "value", "CensusYear",
      "Census.Year", "HalfYear", "Intercensal.Period"
    )
    
    if (wide_format == "very_wide") {
      remove <- append(remove, "Statistic")
    }
    
    row_vars <- string [!string %in% remove]
    
    wide_data <- reshape2::dcast(data, formula = paste(
      paste(row_vars, collapse = " + "), " ~ ... "
    ))
    
    if (!use_factors) {
      wide_data <- dplyr::mutate_if(wide_data, is.factor, as.character)
    }
    
    return(wide_data)
  } else {
    return(data)
  }
}

#' Download a CSO table as a data frame
#'
#' Internal function to return a CSO table from the CSO PxStat Application
#' Programming Interface (API) as a JSON-stat dataset.
#'
#' The data is pulled from the ReadDataset service on the CSO API in
#' JSON-Stat format, using the GET method from the httr package.
#'
#' To improve performance, the result is cached by default.
#'
#' @param table_code string. The code uniquely identifying one table.
#' @param cache logical. Indicates whether to cache the result using R.cache.
#' @param suppress_messages logical. If FALSE (default) a message is printed
#' when loading a previously cached data table.
#' @param flush_cache logical. If TRUE (default) the cache will be checked for 
#' old, unused files. Any files which have not been accessed in the last month 
#' will be deleted
#' @return a character object, containing the data in JSON-stat format.
#' @noRd
#' @importFrom utils fileSnapshot


cso_download_tbl <- function(table_code, cache = TRUE,
                             suppress_messages = FALSE, flush_cache = TRUE) {
  url <- paste0(
    "https://ws.cso.ie/public/api.restful/PxStat.Data.Cube_API.ReadDataset/",
    table_code, "/JSON-stat/2.0/en"
  )
  
  # Attempt to retrieve cached data -----
  if (cache) {
    toc <- cso_get_toc(suppress_messages = TRUE)
    last_update <- toc[toc$id == table_code, 1]
    data <- R.cache::loadCache(list(table_code, last_update), dirs = "csodata")
    if (!is.null(data)) {
      if (!suppress_messages) {
        message("Loaded cached data\n")
      }
      return(data)
    }
  }
  
  #Empty out the cache of unused files if a new file is being downloaded
  if(flush_cache){
    file.remove(
      rownames(
        fileSnapshot(paste0(R.cache::getCacheRootPath(),"/csodata"), full.names = T, recursive = T)$info[!lubridate::`%within%`(
          fileSnapshot(paste0(R.cache::getCacheRootPath(),"/csodata"), full.names = T, recursive = T)$info[,"mtime"],
          lubridate::interval(start = Sys.Date() - lubridate::days(2) , end = Sys.Date() + lubridate::days(1))) , ]
      )
    )
  } 
  
  
  # No caching, or cache empty ----------
  
  # Check for errors using trycatch since PxStat API does not support
  # html head requests.
  error_message =  paste0("Failed retrieving table. Please check internet ",
                          "connection and that data .cso.ie is online")
  
  response <- tryCatch({
    httr::GET(url)
  }, warning = function(w) {
    print(paste0("Warning: ", error_message))
    return(NULL)
  }, error = function(e) {
    message(paste0("Connection Error: ", error_message))
    return(NULL)
  })
  
  #Cut off if theres issues
  if(is.null(response)){return(NULL)}
  
  # Check if data valid -------------
  if (httr::status_code(response) == 200 &&
      !all(response[["content"]][1:32] ==
           charToRaw("invalid Maintable format entered"))) {
    json_data <- rawToChar(response[["content"]])
    if (cache) {
      toc <- cso_get_toc(suppress_messages = TRUE)
      last_update <- toc[toc$id == table_code, 1]
      R.cache::saveCache(json_data,
                         key = list(table_code, last_update), dirs = "csodata"
      )
    }
    return(json_data)
  } else {
    stop("Not a valid table code. See cso_get_toc() for all valid tables.")
  }
}

#' Returns a data frame with the metadata of a CSO data table
#'
#' Checks the CSO PxStat API for a metadata on a dataset and returns it as a
#' list of metadata and contained statistics.
#'
#'
#' @param table_code string. A valid code for a table on data.cso.ie .
#' @param cache logical. Whether to use cached data, if available.
#' Default value is TRUE.
#' @param flush_cache logical. If TRUE (default) the cache will be checked for old, unused
#' files. Any files which have not been accessed in the last month will be deleted
#' @return list with eight elements:
#' \itemize{
#'   \item The title of the table.
#'   \item The units used (the R class of the value column)
#'   \item The Copyright on the data.
#'   \item The time interval used in the data. (Census year, Quarter, Month)
#'   \item The date the table was last modified.
#'   \item The names of the variables included in the table, returned as a
#'   character vector with one element for each variable.
#'   \item The names of the statistics included in the table, returned as a
#'   character vector with one element for each statistic.
#'   \item An indicator if the statistics are experimental
#' }
#' @export
#' @examples
#' meta1 <- cso_get_meta("HS014", cache = FALSE)
#' 
cso_get_meta <- function(table_code, cache = TRUE, flush_cache = TRUE) {
  # Use fromJSON in order to preserve metadata ---
  tbl <- cso_download_tbl(table_code, cache, flush_cache)
  # Error Checking ----------------------
  if (is.null(tbl)) {
    return(NULL)
  }
  
  response_fj <- jsonlite::fromJSON(tbl)
  title <- response_fj$label
  
  time_period <- response_fj$dimension[[2]]$label 
  units <- response_fj$dimension$STATISTIC$category$unit[[1]]$label
  date_modified <- response_fj$updated
  vars <- setdiff(names(rjstat::fromJSONstat(tbl,naming = "label", use_factors = TRUE)), c("Statistic","value"))
  stat <- as.character(response_fj$dimension$STATISTIC$category$label)
  
  copyright <- response_fj$extension$copyright$name
  experimental <- response_fj$extension$experimental
  
  list(
    Title = title, Time = time_period,
    Units = units, Date_last_modified = date_modified,
    Variables = vars, Statistics = stat,
    Copyright = copyright,
    Is_Experimental = experimental
  )
}


#' Returns a character vector listing the contents of a CSO data table
#'
#' Reads the metadata of a table to return a character vector of the
#' included variables in the table.
#'
#' @param table_code string. A valid code for a table on data.cso.ie .
#' @param cache logical. Whether to use cached data, if available.
#' Default value is TRUE. Strongly recommended to use caching, as otherwise
#' the entire table could be downloaded only to access a small part of its
#' metadata.
#' @param flush_cache logical. If TRUE (default) the cache will be checked for old, unused
#' files. Any files which have not been accessed in the last month will be deleted.
#' @return character vector. The names of the statistics included in the
#' table.
#' @export
#' @examples
#' \dontrun{
#' cso_get_vars("IPA03")
#' }
cso_get_vars <- function(table_code, cache = TRUE, flush_cache = TRUE) {
  tbl <- cso_download_tbl(table_code, cache, flush_cache)
  # Error Checking ----------------------
  if (is.null(tbl)) {
    return(NULL)
  }
  
  setdiff(names(rjstat::fromJSONstat(tbl,naming = "label", use_factors = TRUE)), c("Statistic","value"))
}


#' Returns a list of the values of variables of a CSO data table
#'
#' Reads the table to determine all the unique values taken by the
#' variables in the table and returns them as a list.
#'
#' @param table_code string. A valid code for a table on data.cso.ie .
#' @param cache logical. Whether to use cached data, if available.
#' Default value is TRUE.
#' @param flush_cache logical. If TRUE (default) the cache will be checked for old, unused
#' files. Any files which have not been accessed in the last month will be deleted
#' @return list. It has length equal to the number of variables in the table,
#' and each element is a character vector which has all the values taken by
#' one variable.
#' @export
#' @examples
#' \dontrun{
#' var_val <- cso_get_var_values("IPA03")
#' }
#' 
cso_get_var_values <- function(table_code, cache = TRUE, flush_cache = TRUE) {
  tbl <- cso_download_tbl(table_code, cache, flush_cache)
  # Error Checking ----------------------
  if (is.null(tbl)) {
    return(NULL)
  }
  
  response_fj <- jsonlite::fromJSON(tbl)
  vars <- setdiff(names(rjstat::fromJSONstat(tbl,naming = "id", use_factors = TRUE)), "value")
  len <- length(vars)
  var_vec <- vector(mode = "list", length = len)
  names(var_vec) <- setdiff(names(rjstat::fromJSONstat(tbl,naming = "label", use_factors = TRUE)), "value")
  for (i in 1:len) {
    response_fj$dimension
    string <- paste0("response_fj$dimension$`",
                     vars[i], "`$category$label")
    var_vec[i] <-  list(as.vector(unlist(eval(parse(text = string)))))
  }
  
  return(var_vec)
}


#' Returns a the time interval used to record data in a CSO table
#'
#' Reads the metadata of a table to return an atomic character vector
#' displaying the intervals at which the data included in the table was
#' gathered/calculated.
#'
#' @param table_code string. A valid code for a table on data.cso.ie .
#' @param cache logical. Whether to use cached data, if available.
#' Default value is TRUE. Strongly recommended to use caching, as otherwise
#' the entire table could be downloaded only to access a small part of its
#' metadata.
#' @param flush_cache logical. If TRUE (default) the cache will be checked for old, unused
#' files. Any files which have not been accessed in the last month will be deleted
#' @return character vector. The names of the statistics included in the
#' table, with one element for each statistic.
#' @export
#' @examples
#' \dontrun{
#' interval <- cso_get_interval("C0636")
#' }
cso_get_interval <- function(table_code, cache = TRUE, flush_cache = TRUE) {
  tbl <- cso_download_tbl(table_code, cache, flush_cache)
  # Error Checking ----------------------
  if (is.null(tbl)) {
    return(NULL)
  }
  
  response_fj <- jsonlite::fromJSON(tbl)
  
  if (!is.null(response_fj$dimension[[2]]$category$index)) {
    out <- response_fj$dimension[[2]]$category$index 
  } else {
    out <- "There is no time interval information for this PxStat table"
  }
  return(out)
}


#' Returns a character vector listing the statistics in a CSO data table
#'
#'
#' @param table_code string. A valid code for a table on data.cso.ie .
#' @param cache logical. Whether to use cached data, if available.
#' Default value is TRUE.
#' @param flush_cache logical. If TRUE (default) the cache will be checked for old, unused
#' files. Any files which have not been accessed in the last month will be deleted
#' @return character vector. The names of the statistics included in the
#' table, with one element for each statistic.
#' @export
#' @examples
#' \dontrun{
#' var_cont <- cso_get_content("EP008")
#' }
cso_get_content <- function(table_code, cache = TRUE, flush_cache = TRUE) {
  # Pull the list from API and keep only useful column -----
  tbl <- cso_download_tbl(table_code, cache, flush_cache)
  # Error Checking ----------------------
  if (is.null(tbl)) {
    return(NULL)
  }
  
  response_fj <- jsonlite::fromJSON(tbl)
  
  as.character(response_fj$dimension$STATISTIC$category$label)
}


#' Prints metadata from a PxStat table to the console
#'
#' Takes the output from \code{\link{cso_get_meta}} and prints it to the
#' console as formatted text.
#'
#' @param table_code string. A valid code for a table on data.cso.ie .
#' @return Does not return any values, rather the function prints the tables metadata to console.
#' @export
#' @examples
#' \dontrun{
#' cso_disp_meta("EP001")
#' }
cso_disp_meta <- function(table_code) {
  meta <- cso_get_meta(table_code, flush_cache = FALSE)
  
  # Error Checking ----------------------
  if (is.null(meta)) {
    return(NULL)
  }
  
  message("*** METADATA ***\n")
  message("CSO Table = ", meta$Title, "\n")
  message("Units = ", meta$Units, "\n")
  message("Copyright = ", meta$Copyright, "\n")
  message("Time interval in data = ", meta$Time, "\n")
  message("Are these statistics experimental? -", meta$Is_Experimental, "\n")
  message("Date last modified = ", meta$Date_last_modified, "\n")
  message("Variables:")
  print(meta$Variables)
  message("\nStatistics:")
  print(meta$Statistics)
}

---
title: "csodata quick start guide"
date: "`r Sys.Date()`"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{csodata quick start guide}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

#### Introduction

This guide provides a basic overview of the use of the csodata package for new users. Install (if necessary) and load the package:

```{r setup}
# # Install or update the package:
# install.packages("csodata")

library(csodata)
```

#### Table of Contents

A list of all the table available on the cso StatBank can be downloaded with `cso_get_toc`. You can search throught the title field using `cso_search_toc`. (A "Loaded cached toc" or "Loaded cached data" message indicates that the data was retrieved from the cache, instead of being downloaded again.)
```{r}
toc <- cso_get_toc()
head(toc)
```

#### Downloading Data

To download a dataset, use `cso_get_data`.

```{r}
tbl1 <- cso_get_data("PEA19")
```

Metadata can be also downloaded or displayed to console:

```{r}
meta1 <- cso_get_meta("CDP06")
cso_disp_meta("CDP06")
```

#### Geographic Data

Geographic vector data in ESRI shapefile format can be downloaded for use in mapping. This uses the older 2011 data, which includes demographic information. Newer maps, including the revisions to the NUTS regions made in 2016, is also available.

```{r}
shp <- cso_get_geo("NUTS3_2011")
```

This data can be plotted using the `tmap` package. Here we plot the 2011 population, which is included as the "TOTAL2011" column in the map data.

```{r, fig.width = 5, fig.height=6}
# install.packages("tmap")
library(tmap)

t <- tm_shape(shp) +
       tm_fill(col="TOTAL2011", 
                    palette = viridisLite::viridis(20),
                    style="cont", legend.reverse = TRUE,
                    title = "Population 2011") +
       tm_borders(col = "black") +
       tm_layout(frame = FALSE, scale = 1.3)
t
```

The data which has been cached locally can be manually cleared once we are done with it.

```{r}
cso_clear_cache()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cso_get_meta.R
\name{cso_get_interval}
\alias{cso_get_interval}
\title{Returns a the time interval used to record data in a CSO table}
\usage{
cso_get_interval(table_code, cache = TRUE, flush_cache = TRUE)
}
\arguments{
\item{table_code}{string. A valid code for a table on data.cso.ie .}

\item{cache}{logical. Whether to use cached data, if available.
Default value is TRUE. Strongly recommended to use caching, as otherwise
the entire table could be downloaded only to access a small part of its
metadata.}

\item{flush_cache}{logical. If TRUE (default) the cache will be checked for old, unused
files. Any files which have not been accessed in the last month will be deleted}
}
\value{
character vector. The names of the statistics included in the
table, with one element for each statistic.
}
\description{
Reads the metadata of a table to return an atomic character vector
displaying the intervals at which the data included in the table was
gathered/calculated.
}
\examples{
\dontrun{
interval <- cso_get_interval("C0636")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cso_get_data.R
\name{cso_get_data}
\alias{cso_get_data}
\title{Return a CSO table as a data frame}
\usage{
cso_get_data(
  table_code,
  wide_format = "wide",
  include_ids = FALSE,
  id_list = NULL,
  use_factors = TRUE,
  cache = TRUE,
  flush_cache = TRUE
)
}
\arguments{
\item{table_code}{string. If the table_code is a filename or a path to a
file, e.g. "QNQ22.json", it is imported from that file. Otherwise if it is
only a table code e.g. "QNQ22", the file is downloaded from data.cso and
checked to see if it is a valid table.}

\item{wide_format}{string, one of "wide", "very_wide" or "tall". If "wide"
(default) the table is returned in wide (human readable) format, with
statistic as a column (if it exists). If "very_wide" the table is returned
wide format and spreads the statistic column to rows. If "tall" the table is
returned in tall (statistic and value) format.}

\item{include_ids}{logical. The JSON-stat format stores variables as ids
i.e. IE11 and labels i.e. Border. While the label is generally preferred,
sometimes it is useful to have the ids to match on. If \code{include_ids}
is TRUE (default) then ids are retrieved and appended to the table to the
right of the original column with the name <columnName>.id.}

\item{id_list}{either NULL (default) or a character vector of columns that
should have ids appended if include_ids is TRUE.
if NULL then every column that is not included in the vector
\code{remove_id} will be used.}

\item{use_factors}{logical. If TRUE (default) factors will be used in
strings.}

\item{cache}{logical. if TRUE (default) csodata will cache the result using
R.cache. The raw data downloaded from the data.csi.ie is cached, which means
that calling \code{cso_get_data} with the same table_code but different
parameterswill result in cached data being used.}

\item{flush_cache}{logical. If TRUE (default) the cache will be checked for 
old, unused files. Any files which have not been accessed in the last month
 will be deleted}
}
\value{
data frame of the requested CSO table.
}
\description{
Returns a CSO table from the CSO PxStat Application Programming Interface
(API) as a data frame, with the option to give it in wide format (default)
very wide or long format.
}
\details{
The data is pulled from the ResponseInstance service on the CSO API in
JSON-Stat fromat, using the GET method from the httr package.
}
\examples{
\dontrun{
tbl1 <- cso_get_data("QNQ22")
tbl2 <- cso_get_data("QLF07.json")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cso_get_meta.R
\name{cso_get_var_values}
\alias{cso_get_var_values}
\title{Returns a list of the values of variables of a CSO data table}
\usage{
cso_get_var_values(table_code, cache = TRUE, flush_cache = TRUE)
}
\arguments{
\item{table_code}{string. A valid code for a table on data.cso.ie .}

\item{cache}{logical. Whether to use cached data, if available.
Default value is TRUE.}

\item{flush_cache}{logical. If TRUE (default) the cache will be checked for old, unused
files. Any files which have not been accessed in the last month will be deleted}
}
\value{
list. It has length equal to the number of variables in the table,
and each element is a character vector which has all the values taken by
one variable.
}
\description{
Reads the table to determine all the unique values taken by the
variables in the table and returns them as a list.
}
\examples{
\dontrun{
var_val <- cso_get_var_values("IPA03")
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cso_get_geo.R
\name{cso_get_geo}
\alias{cso_get_geo}
\title{Return geographic data as a sf data frame}
\usage{
cso_get_geo(map_data, cache = TRUE, flush_cache = TRUE)
}
\arguments{
\item{map_data}{string. Indicates which shapefile to download. Options are:
\itemize{
  \item "Provinces" OR "p",
  \item "NUTS2",
  \item "NUTS3",
  \item "NUTS2_2011",
  \item "NUTS3_2011",
  \item "Administrative Counties" OR "admin_counties" OR "ac",
  \item "Electoral Divisions" OR "elec_div" OR "ed",
  \item "Small Areas" OR "sa" and
  \item "Gaeltacht" OR "g".
}
Until v0.1.5 "NUTS2" and "NUTS3" gave access to the 2011 dataset.}

\item{cache}{logical. Indicates whether to cache the result using R.cache.
TRUE by default.}

\item{flush_cache}{logical. If TRUE (default) the cache will be checked for old, unused
files. Any files which have not been accessed in the last month will be deleted}
}
\value{
data frame of the requested CSO table.
}
\description{
Retrieves an ESRI shapefile of vector data for Ireland from the cso website
\href{https://www.cso.ie/en/census/census2011boundaryfiles/}{cso.ie} and
returns it as an sf data frame. The data is returned as a zip file, which is
downloaded to and unzipped in a temporary directory.
}
\details{
The map data is from the 2011 census, and is 20m generalised, which offers a
good balance of fidelity and low file size. More datasets, as well as
50m generalised, 100m generalised and ungeneralised versions of the map
files can also be found on the OSi (Ordnance Survey Ireland) website at
\url{https://data-osi.opendata.arcgis.com/search?tags=boundaries}.

The NUTS2 and NUTS3 map files are the updated versions for 2016, including
three NUTS2 regions and the movement of Louth and South Tipperary into new
NUTS3 regions. These files are downloaded directly from the OSi website, as
they are not available on the CSO website, and do not contain the population
and housing data contained in the map files from the CSO website.
}
\examples{
\dontrun{
shp <- cso_get_geo("NUTS2")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/csodata.R
\name{cso_clear_cache}
\alias{cso_clear_cache}
\title{Clear csodata cache}
\usage{
cso_clear_cache()
}
\value{
Does not return a value, deletes the csodata cache.
}
\description{
Deletes all data cached by the csodata package. The cached data from the
csodata package is stored in a subdirectory of the default R.cache cache
at R.cache::getCachePath(). This function provides a quick way to delete
those files along with the directory to free up space.
}
\examples{
\dontrun{
cso_clear_cache()
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cso_get_meta.R
\name{cso_get_meta}
\alias{cso_get_meta}
\title{Returns a data frame with the metadata of a CSO data table}
\usage{
cso_get_meta(table_code, cache = TRUE, flush_cache = TRUE)
}
\arguments{
\item{table_code}{string. A valid code for a table on data.cso.ie .}

\item{cache}{logical. Whether to use cached data, if available.
Default value is TRUE.}

\item{flush_cache}{logical. If TRUE (default) the cache will be checked for old, unused
files. Any files which have not been accessed in the last month will be deleted}
}
\value{
list with eight elements:
\itemize{
  \item The title of the table.
  \item The units used (the R class of the value column)
  \item The Copyright on the data.
  \item The time interval used in the data. (Census year, Quarter, Month)
  \item The date the table was last modified.
  \item The names of the variables included in the table, returned as a
  character vector with one element for each variable.
  \item The names of the statistics included in the table, returned as a
  character vector with one element for each statistic.
  \item An indicator if the statistics are experimental
}
}
\description{
Checks the CSO PxStat API for a metadata on a dataset and returns it as a
list of metadata and contained statistics.
}
\examples{
meta1 <- cso_get_meta("HS014", cache = FALSE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cso_get_meta.R
\name{cso_get_content}
\alias{cso_get_content}
\title{Returns a character vector listing the statistics in a CSO data table}
\usage{
cso_get_content(table_code, cache = TRUE, flush_cache = TRUE)
}
\arguments{
\item{table_code}{string. A valid code for a table on data.cso.ie .}

\item{cache}{logical. Whether to use cached data, if available.
Default value is TRUE.}

\item{flush_cache}{logical. If TRUE (default) the cache will be checked for old, unused
files. Any files which have not been accessed in the last month will be deleted}
}
\value{
character vector. The names of the statistics included in the
table, with one element for each statistic.
}
\description{
Returns a character vector listing the statistics in a CSO data table
}
\examples{
\dontrun{
var_cont <- cso_get_content("EP008")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cso_get_geo.R
\name{cso_get_geo_meta}
\alias{cso_get_geo_meta}
\title{Returns a data frame with the metadata of a vector shapefile}
\usage{
cso_get_geo_meta(shp)
}
\arguments{
\item{shp}{sf data.frame. Geographic data stored as an sf object.}
}
\value{
list with eight elements:
\itemize{
  \item The coordinate reference system, itself a list with two elements,
  the EPSG code (if any, NA value if none), and the proj4string
  \item The number of polygons in the data
  \item If all the polygons are simple (not self-intersecting)
  \item If any polygons are empty
  \item If all of the polygons are valid
  \item The average area of the polygons, including units
}
}
\description{
Takes the output from \code{\link{cso_get_geo}} or otherwise and returns
information about it in a data frame.
}
\examples{
\dontrun{
shp_meta <- cso_get_geo_meta(shp)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/csodata.R
\docType{package}
\name{csodata}
\alias{csodata}
\title{csodata: A package for downloading CSO data.}
\description{
The csodata package allows for easily downloading CSO (Central Statistics
Office, the National Statistics Institute of Ireland) PxStat data into R.
}
\details{
A specific table can be downloaded using \code{\link{cso_get_data}},
while a list of all tables currently available and their titles can
be found using \code{\link{cso_get_toc}} and \code{\link{cso_search_toc}}
is used to search their descriptions.
Metadata for a specified table can be retrieved with
\code{\link{cso_get_meta}}, or printed on the console using
\code{\link{cso_disp_meta}}.

\code{\link{cso_get_vars}}, \code{\link{cso_get_interval}}, and
\code{\link{cso_get_content}} all return a subset of the full metadata of
a table. \code{\link{cso_get_var_values}} returns all the variables in the
tables.

These functions provide the option to cache the returned data using the
R.cache package. The cache can be deleted using
\code{\link{cso_clear_cache}}.

ESRI shapefiles covering the country in varying degrees of granularity can
be downloaded from
\href{https://www.cso.ie/en/census/census2011boundaryfiles/}{cso.ie} and
imported as an sf data frame using the \code{\link{cso_get_geo}} function.
Metadata about the map data can be retrieved with
\code{\link{cso_get_geo_meta}}, and displayed on the console with
\code{\link{cso_disp_geo_meta}}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cso_get_geo.R
\name{cso_disp_geo_meta}
\alias{cso_disp_geo_meta}
\title{Prints metadata from an ESRI shapefile to console}
\usage{
cso_disp_geo_meta(shp)
}
\arguments{
\item{shp}{sf data.frame. Geographic data stored as an sf object.}
}
\value{
Does not return any values, rather the function prints the shapefile metadata to console.
}
\description{
Takes the output from \code{\link{cso_get_geo}} or otherwise and prints
information about it to the console as formatted text.
}
\examples{
\dontrun{
cso_disp_geo_meta(shp)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cso_get_meta.R
\name{cso_disp_meta}
\alias{cso_disp_meta}
\title{Prints metadata from a PxStat table to the console}
\usage{
cso_disp_meta(table_code)
}
\arguments{
\item{table_code}{string. A valid code for a table on data.cso.ie .}
}
\value{
Does not return any values, rather the function prints the tables metadata to console.
}
\description{
Takes the output from \code{\link{cso_get_meta}} and prints it to the
console as formatted text.
}
\examples{
\dontrun{
cso_disp_meta("EP001")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cso_get_toc.R
\name{cso_get_toc}
\alias{cso_get_toc}
\title{Returns a data frame with all valid CSO PxStat tables listed sequentially
by id number, e.g. A0101, A0102, A0103, etc.}
\usage{
cso_get_toc(
  cache = TRUE,
  suppress_messages = FALSE,
  get_frequency = FALSE,
  list_vars = FALSE,
  flush_cache = TRUE
)
}
\arguments{
\item{cache}{logical. If TRUE (default) the table of contents is cached
with the system date as a key.}

\item{suppress_messages}{logical. If FALSE (default) a message is printed
when loading a previously cached table of contents.}

\item{get_frequency}{logical. If TRUE the frequency of each 
table(yearly, monthly etc...) will be returned as an additional column in 
the table of contents}

\item{list_vars}{logical. If TRUE an additional column will be added
to the table of contents which lists each tables variables.}

\item{flush_cache}{logical. If TRUE (default) the cache will be checked for 
old, unused files. Any files which have not been accessed in the last month 
will be deleted}
}
\value{
data frame of three character columns:
\itemize{
  \item id. Contains all of the table codes currently
available on the CSO API.
  \item LastModified. The date the table was last modified in POSIXct
  format.
  \item title. The title of the table.
}
}
\description{
Checks the CSO PxStat API for a list of all the table codes (e.g. A0101,
A0102, A0103, etc.), which also includes date last modified and title for
each table, and returns this list as an R data frame.
}
\details{
The data is pulled from the ReadCollection on the CSO API. See
\url{https://github.com/CSOIreland/PxStat/wiki/API-Cube-RESTful}
for more information on this.
}
\examples{
\dontrun{
head(cso_get_toc())
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cso_get_toc.R
\name{cso_search_toc}
\alias{cso_search_toc}
\title{Search list of all table descriptions for given string}
\usage{
cso_search_toc(
  string,
  toc = cso_get_toc(suppress_messages = TRUE, flush_cache = FALSE)
)
}
\arguments{
\item{string}{string. The text to search for. Case insensitive.}

\item{toc}{data.frame. The table of contents as returned by cso_get_toc. If
not given, will be re-downloaded (or retrieved from cache) using
cso_get_toc().}

\item{flush_cache}{logical. If TRUE  the cache will be checked for old, unused
files. Any files wich have not been accessed in the last month will be deleted
strings.}
}
\value{
data frame of three character columns, with layout identical to
that of cso_get_toc. A subset of the results of cso_get_toc, with only rows
where the description field contains the entered string.
}
\description{
Searches the list of all table descriptions returned by cso_get_toc() for a
given substring.
}
\examples{
\dontrun{
trv <- cso_search_toc("travel")
}
}
